function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useState } from 'react';
import { Popover } from 'antd';
import { SmileOutlined } from '@ant-design/icons';
// @ts-ignore
import emojis from "./emoji-data";
import "../../assets/css/emoji-sprite.less";
import "./index.less";
var pannels = ['表情', '自然', '物品', '地点', '符号'];
var emojiData = pannels.map(function (item) {
  return Object.keys(emojis[item]);
});
var EmojiPanel = function EmojiPanel(props) {
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    visibleEmoji = _useState2[0],
    setVisibleEmoji = _useState2[1];
  var handleVisibleChange = function handleVisibleChange(visible) {
    return setVisibleEmoji(visible);
  };

  // 表情onChange
  var onChangeTita = function onChangeTita(code) {
    var value = props.value,
      insertIndex = props.insertIndex;
    var modifiedValue = value.slice(0, insertIndex).concat(code, value.slice(insertIndex));
    props.onChangeInput(modifiedValue);
    // 关掉emoji弹框
    setVisibleEmoji(false);
  };
  return /*#__PURE__*/React.createElement("span", {
    className: "emoji-btn"
  }, /*#__PURE__*/React.createElement(Popover, {
    open: visibleEmoji,
    onOpenChange: handleVisibleChange,
    placement: "bottom",
    content: /*#__PURE__*/React.createElement(Content, {
      onChange: onChangeTita
    }),
    trigger: "click"
  }, /*#__PURE__*/React.createElement(SmileOutlined, null)));
};
var Content = function Content(props) {
  var _useState3 = useState(0),
    _useState4 = _slicedToArray(_useState3, 2),
    activeIndex = _useState4[0],
    setActiveIndex = _useState4[1];
  var changeActive = function changeActive(idx) {
    return setActiveIndex(idx);
  };
  var getPureName = function getPureName(name) {
    return name.replace(/:/g, '');
  };
  var selectItem = function selectItem(code) {
    return props.onChange(code);
  };
  return /*#__PURE__*/React.createElement("div", {
    className: "emoji"
  }, /*#__PURE__*/React.createElement("ul", {
    className: "emoji-controller"
  }, pannels.map(function (item, index) {
    return /*#__PURE__*/React.createElement("li", {
      key: item,
      onClick: function onClick() {
        return changeActive(index);
      },
      className: index === activeIndex ? 'active' : ''
    }, item);
  })), /*#__PURE__*/React.createElement("ul", {
    className: "emoji-container"
  }, emojiData.map(function (emojiGroup, index) {
    return index === activeIndex && /*#__PURE__*/React.createElement("li", {
      key: emojiGroup[0]
    }, emojiGroup.map(function (emoji) {
      return /*#__PURE__*/React.createElement("a", {
        key: emoji,
        onClick: function onClick() {
          return selectItem(emoji);
        }
      }, /*#__PURE__*/React.createElement("span", {
        title: emoji,
        className: "emoji-item sprite-".concat(getPureName(emoji))
      }));
    }));
  })));
};
export default EmojiPanel;